/* 
 * File:   main.c
 * Author: cseebach
 *
 * Created on May 2, 2012, 3:54 PM
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <fcntl.h>

int BUFFER_SIZES[] = {1024, 2048, 4096, 8192, 16384, 32768, 65536, 131072,
                      262144, 524288, 1048576, 2097152, 4194304};
int NUM_BUFFER_SIZES = sizeof(BUFFER_SIZES)/sizeof(int);

const char *TEST_FILE = "test_file.dat";

/*
 * 
 */
int main(int argc, char** argv) {

    int i;
    for (i = 0; i < NUM_BUFFER_SIZES; i++){
        int buffer_size = BUFFER_SIZES[i];
        
        clock_t start = clock();
        int test_file = open(TEST_FILE, O_RDONLY);
        int j;
        for (j = 0; j < 2000; j++){
            char *buffer = (char*) malloc(buffer_size);
            read(test_file, buffer, buffer_size);
            free(buffer);
        }
        close(test_file);
        clock_t time = clock() - start;
        
        
        printf("%5d\t%7d\n", time, buffer_size);
    }
    
    return (EXIT_SUCCESS);
}

